""" Local Skin: Enable change skins on folder

Copyright (c) 2004-2005 Local Skin development team

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Id: Install.py, sandro lourenco(Zefyrus)
instalation file
"""
__author__ = 'Sandro Loureco aka Zefyrus'
__docformat__ = 'restructuredtext'

import os.path
import string
from Globals import package_home
from Acquisition import aq_base
from StringIO import StringIO
from OFS.ObjectManager import BadRequestException
from Products.CMFCore.utils import getToolByName, minimalpath
from Products.CMFCore.DirectoryView import createDirectoryView
from Products.CMFPlone import cmfplone_globals
from Products.LocalSkin.config import *
from Products.CMFCore.utils import getToolByName
from Products.ZCatalog.Catalog import CatalogError
from Products.Archetypes.Extensions.utils import installTypes, install_subskin


def install(self):
    out = StringIO()
    
    install_subskin(self, out, GLOBALS)
    modify_catalog(self, out)
    install_tools(self, PROJECTNAME, [('local_skin_tool', 'Local Skin Tool')], out)
    
def install_tools(self, product, tools, out):
    addTool = self.manage_addProduct[product].manage_addTool
    for toolid, toolname in tools:
        if hasattr(self, toolid):
            self.manage_delObjects(ids=[toolid])
        addTool(toolname)
        out.write("Created tool: %s (%s).\n" % (toolid, toolname))

def modify_catalog(self, out):
    """Add local_skin metadata to catalog
    """
    cat = getToolByName(self, 'portal_catalog')
    try:
        cat.addColumn('getLocalSkin')
    except CatalogError:
        print >>out, 'portal_catalog already has local_skin metadata, recreate it'
        # read the local_skin metadata
        cat.delColumn('getLocalSkin')
        cat.addColumn('getLocalSkin')
    else:
        print >>out, 'Added local_skin metadata to portal_catalog'
    cat.refreshCatalog()

